import { Properties } from '../types';
export declare const _info: {
    campaignParams: (customParams?: string[]) => Record<string, any>;
    searchEngine: () => string | null;
    searchInfo: () => Record<string, any>;
    /**
     * This function detects which browser is running this script.
     * The order of the checks are important since many user agents
     * include key words used in later checks.
     */
    browser: (user_agent: string, vendor: string | undefined, opera?: any) => string;
    /**
     * This function detects which browser version is running this script,
     * parsing major and minor version (e.g., 42.1). User agent strings from:
     * http://www.useragentstring.com/pages/useragentstring.php
     *
     * `navigator.vendor` is passed in and used to help with detecting certain browsers
     * NB `navigator.vendor` is deprecated and not present in every browser
     */
    browserVersion: (userAgent: string, vendor: string | undefined, opera: string) => number | null;
    browserLanguage: () => string;
    os: (user_agent: string) => {
        os_name: string;
        os_version: string;
    };
    device: (user_agent: string) => string;
    deviceType: (user_agent: string) => string;
    referrer: () => string;
    referringDomain: () => string;
    properties: () => Properties;
    people_properties: () => Properties;
};
