import { Breaker, EventHandler, Properties } from '../types';
export declare const _trim: (str: string) => string;
export declare const _bind_instance_methods: (obj: Record<string, any>) => void;
export declare function _eachArray<E = any>(obj: E[] | null | undefined, iterator: (value: E, key: number) => void | Breaker, thisArg?: any): void;
/**
 * @param {*=} obj
 * @param {function(...*)=} iterator
 * @param {Object=} thisArg
 */
export declare function _each(obj: any, iterator: (value: any, key: any) => void | Breaker, thisArg?: any): void;
export declare const _extend: (obj: Record<string, any>, ...args: Record<string, any>[]) => Record<string, any>;
export declare const _include: (obj: null | string | Array<any> | Record<string, any>, target: any) => boolean | Breaker;
export declare function _includes<T = any>(str: T[] | string, needle: T): boolean;
/**
 * Object.entries() polyfill
 * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/entries
 */
export declare function _entries<T = any>(obj: Record<string, T>): [string, T][];
export declare const _isValidRegex: (str: string) => boolean;
export declare const _encodeDates: (obj: Properties) => Properties;
export declare const _timestamp: () => number;
export declare const _formatDate: (d: Date) => string;
export declare const _try: <T>(fn: () => T) => T | undefined;
export declare const _safewrap: <F extends (...args: any[]) => any = (...args: any[]) => any>(f: F) => F;
export declare const _safewrap_class: (klass: Function, functions: string[]) => void;
export declare const _safewrap_instance_methods: (obj: Record<string, any>) => void;
export declare const _strip_empty_properties: (p: Properties) => Properties;
export declare function _copyAndTruncateStrings<T extends Record<string, any> = Record<string, any>>(object: T, maxStringLength: number | null): T;
export declare function _base64Encode(data: null): null;
export declare function _base64Encode(data: undefined): undefined;
export declare function _base64Encode(data: string): string;
export declare const _utf8Encode: (string: string) => string;
export declare const _register_event: (element: Element | Window | Document | Node, type: string, handler: EventHandler, oldSchool?: boolean, useCapture?: boolean) => void;
export declare function loadScript(scriptUrlToLoad: string, callback: (error?: string | Event, event?: Event) => void): void;
export declare function isCrossDomainCookie(documentLocation: Location | undefined): boolean;
export declare function isDistinctIdStringLike(value: string): boolean;
