// eslint-disable-next-line posthog-js/no-direct-array-check
var nativeIsArray = Array.isArray;
var ObjProto = Object.prototype;
export var hasOwnProperty = ObjProto.hasOwnProperty;
var toString = ObjProto.toString;
export var _isArray = nativeIsArray ||
    function (obj) {
        return toString.call(obj) === '[object Array]';
    };
export var _isUint8Array = function (x) {
    return toString.call(x) === '[object Uint8Array]';
};
// from a comment on http://dbj.org/dbj/?p=286
// fails on only one very rare and deliberate custom object:
// let bomb = { toString : undefined, valueOf: function(o) { return "function BOMBA!"; }};
export var _isFunction = function (f) {
    // eslint-disable-next-line posthog-js/no-direct-function-check
    return typeof f === 'function';
};
// Underscore Addons
export var _isObject = function (x) {
    // eslint-disable-next-line posthog-js/no-direct-object-check
    return x === Object(x) && !_isArray(x);
};
export var _isEmptyObject = function (x) {
    if (_isObject(x)) {
        for (var key in x) {
            if (hasOwnProperty.call(x, key)) {
                return false;
            }
        }
        return true;
    }
    return false;
};
export var _isUndefined = function (x) {
    return x === void 0;
};
export var _isString = function (x) {
    // eslint-disable-next-line posthog-js/no-direct-string-check
    return toString.call(x) == '[object String]';
};
export var _isNull = function (x) {
    // eslint-disable-next-line posthog-js/no-direct-null-check
    return x === null;
};
export var _isDate = function (x) {
    // eslint-disable-next-line posthog-js/no-direct-date-check
    return toString.call(x) == '[object Date]';
};
export var _isNumber = function (x) {
    // eslint-disable-next-line posthog-js/no-direct-number-check
    return toString.call(x) == '[object Number]';
};
export var _isBoolean = function (x) {
    // eslint-disable-next-line posthog-js/no-direct-boolean-check
    return toString.call(x) === '[object Boolean]';
};
//# sourceMappingURL=type-utils.js.map